/*
 *  RapidMiner PaREn Automatic System Construction Extension 
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.dfki.madm.mlwizard.landmarking;

import java.util.Map;

import com.rapidminer.example.ExampleSet;
import com.rapidminer.operator.OperatorCreationException;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.learner.tree.DecisionStumpLearner;
import com.rapidminer.tools.OperatorService;

/**
 * This landmark learner is a {@link DecisionStumpLearner}, where a single
 * decision node is chosen according to the highest gain ratio.
 * 
 * @author Sarah Daniel
 * 
 */
public class DecisionNodeLm extends AbstractLandmarker {
   
    public DecisionNodeLm(ExampleSet exampleSet, Map<String, String> parameters) throws OperatorException, OperatorCreationException {

            this.name = LandmarkingParameters.PARAMETER_DECISION_NODE_LM;

            DecisionStumpLearner learner = OperatorService.createOperator(DecisionStumpLearner.class);
            exampleSet = normalizeExampleSet(exampleSet, parameters);

            learnExampleSet(exampleSet, learner, parameters);

    }
}
