/*
 *  RapidMiner PaREn Automatic System Construction Extension 
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.dfki.madm.mlwizard.landmarking;

/**
 * This class contains parameters needed by the {@link LandmarkingOperator} and
 * the {@link AbstractLandmarker}.
 * 
 * @author Sarah Daniel
 * 
 */
public class LandmarkingParameters {
 
    public static final int NUMBER_OF_PERFORMANCE_CRITERIA = 1;

    public static final String PARAMETER_NAIVEBAYES_LM = "Naive Bayes";
    // public static final String PARAMETER_NAIVEBAYES_LM =
    // "Naive Bayes landmark";

    public static final String PARAMETER_KNN_LM = "K-Nearest Neighbour";

    public static final String PARAMETER_KNN_K_VALUE = "K-Value";

    public static final String PARAMETER_DECISION_NODE_LM = "Decision Node";

    public static final String PARAMETER_AVERAGE_NODE_LM = "Average Node";
    // public static final String PARAMETER_AVERAGE_NODE_LM =
    // "Average stump node landmark";

    public static final String PARAMETER_WORST_NODE_LM = "Worst Node";
    // public static final String PARAMETER_WORST_NODE_LM =
    // "Worst stump node landmark";

    public static final String PARAMETER_RANDOMLY_CHOSEN_NODE_LM = "Randomly Chosen Node";

    public static final String PARAMETER_LINEAR_DISCRIMINANT_LM = "Linear Discriminant";
    // public static final String PARAMETER_LINEAR_DISCRIMINANT_LM =
    // "Linear discriminant landmark";

    public static final String PARAMETER_CROSS_VALIDATION = "Cross-validation";

    public static final String PARAMETER_NORMALIZE_EXAMPLESET = "Normalize Dataset";

    public static final String[] NORMALIZATION_METHODS = new String[] { "Z-transformation", "range transformation", "proportion transformation" };

    public static final int METHOD_Z_TRANSFORMATION = 0;

    public static final int METHOD_RANGE_TRANSFORMATION = 1;

    public static final int METHOD_PROPORTION_TRANSFORMATION = 2;

    public static final String PARAMETER_NORMALIZATION_METHOD = "method";

    /** The parameter name for &quot;The minimum value after normalization&quot; */
    public static final String PARAMETER_MIN = "min";

    /** The parameter name for &quot;The maximum value after normalization&quot; */
    public static final String PARAMETER_MAX = "max";

    /**
     * The parameter name for &quot;Number of subsets for the
     * crossvalidation.&quot;
     */
    public static final String PARAMETER_NUMBER_OF_VALIDATIONS = "number_of_validations";

    /**
     * The parameter name for &quot;Set the number of validations to the number
     * of examples. If set to true, number_of_validations is ignored&quot;
     */
    public static final String PARAMETER_LEAVE_ONE_OUT = "leave_one_out";

    /**
     * The parameter name for &quot;Defines the sampling type of the cross
     * validation (linear = consecutive subsets, shuffled = random subsets,
     * stratified = random subsets with class distribution kept constant)&quot;
     */
    public static final String PARAMETER_SAMPLING_TYPE = "sampling_type";

    /**
     * The parameter name for &quot;Indicates if only performance vectors should
     * be averaged or all types of averagable result vectors&quot;
     */
    public static final String PARAMETER_AVERAGE_PERFORMANCES_ONLY = "average_performances_only";

}
